﻿using System;
using System.Collections.Generic;
using System.Data.OleDb;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using UniversalPlantViewerBuilderPlugin.Version1;

namespace ExternalPluginTest
{
    public class Class1 : IPluginVersion1
    {

        public void BeforeExport(IPreExportHook hook)
        {
            hook.BuilderContext.Log("plugin: GetDataFromMDB started..");

            //renaming of attributes:
            //hook.BuilderAttributeAccessor.RenameAttribute("Location", "MyLocation");

            //delete an attribute:
            //hook.BuilderAttributeAccessor.DeleteAttribute("Oid");

            //direct access to elements:
            //var element = hook.BuilderAttributeAccessor.GetElement(new Guid("0003A98C-0000-0000-D35D-C0FC06552004"));

            //update attribute value for elements:
            //element.UpdateAttribute("Status", "asdf");


            

            OleDbConnection cnn;
            OleDbCommand cmd;
            string sql = null;

            string mdbPath = Path.Combine(System.Environment.CurrentDirectory,"IdentNumbers.mdb");
            
            string connectionString = $"Provider=Microsoft.ACE.OLEDB.12.0;Data Source={mdbPath};Persist Security Info = False;";
            cnn = new OleDbConnection(connectionString);
            try
            {
                cnn.Open();
                cmd = new OleDbCommand(sql, cnn);
                
                foreach (var iterateElement in hook.BuilderAttributeAccessor.IterateElements())
                {
                    var elementAttributes = iterateElement.GetAttributes(new HashSet<string>() {"Task", "FileName", "UPVC FileName"});
                    var elementTask = (from a in elementAttributes
                        where a.Key == "Task"
                        select a.Value).FirstOrDefault();

                   string identNumber = string.Empty;

                   if (elementTask == "Piping")
                    {
                        cmd.CommandText = $"select [IdentNumber] from IdentNumbers where OID = '{iterateElement.Uid}'";
                        
                        hook.BuilderContext.Log("SQL: " + cmd.CommandText);

                        identNumber = Convert.ToString(cmd.ExecuteScalar());
                    }
                    else
                    {
                        hook.BuilderContext.Log("plugin: skipping element: " + iterateElement.Uid);
                    }


                    iterateElement.AddAttribute("SDK IdentNumber", identNumber);

                }

                cmd.Dispose();
                cnn.Close();
            }
            catch (Exception ex)
            {
                hook.BuilderContext.Log("plugin: GetDataFromMDB ERROR!");
                hook.BuilderContext.Log(ex.Message);
            }

            hook.BuilderContext.Log("plugin: GetDataFromMDB finished.");
        }

        public int ProcessOrder => 1;
        public string Name => "GetDataFromMDB";
    }
}
