﻿using System;
using System.Collections.Generic;
using UniversalPlantViewerBuilderPlugin.Version1;

namespace UPVBPluginLinks
{
    public class Plugin : IPluginVersion1
    {
        public void BeforeExport(IPreExportHook hook)
        {
            hook.BuilderContext.Log($"{Name}: started...");

            try
            {
                foreach (var element in hook.BuilderElementAccessor.IterateElements())
                {
                    var attributes = hook.BuilderAttributeAccessor.GetAttributes(element, new HashSet<string> { "Uid" });
                    if (!attributes.TryGetValue("Uid", out var uid) || !uid.Equals("000138b6-0000-0000-80f3-55d0615a1e10", StringComparison.InvariantCultureIgnoreCase))
                    {
                        continue;
                    }

                    var color = new Color {A = 255, B = 147, G = 20, R = 255};

                    var link = hook.BuilderLinkAccessor.CreateLink("https://www.google.com/", color, "test");
                    hook.BuilderLinkAccessor.AddRelation(link, element);
                }
            }
            catch (Exception ex)
            {
                hook.BuilderContext.LogError(ex.Message, ex);
            }

            hook.BuilderContext.Log($"{Name}: finished...");
        }

        public int ProcessOrder => 1;
        public string Name => "UPVBPluginLinks";
    }
}