﻿using System;
using System.IO;
using System.Reflection;
using System.Xml;

namespace UPVPluginRenameAttributes
{
    internal class Config
    {
        public string ConnectionString { get; set; }
        public string SheetName { get; set; }

        public Config()
        {
            ReadXmlConfigFile();
        }

        private void ReadXmlConfigFile()
        {
            var path = Path.GetDirectoryName(Assembly.GetExecutingAssembly().CodeBase) ??
                       throw new InvalidOperationException();
            using (var reader = XmlReader.Create(Path.Combine(path, "UPVPluginRenameAttributes.xml")))
            {
                while (reader.Read())
                {
                    if (!reader.IsStartElement()) continue;

                    if (reader.Name == "ConnectionString")
                    {
                        if (reader.Read())
                        {
                            ConnectionString = reader.Value.Trim();
                        }
                    }

                    if (reader.Name == "SheetName")
                    {
                        if (reader.Read())
                        {
                            SheetName = reader.Value.Trim();
                        }
                    }
                }
            }
        }
    }
}